#include <bits/stdc++.h>
using namespace std;
#define endl '\n'
long long a[200001];
int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    long long t, n, k, i;
    cin >> t >> n >> k;
    long long rez = 0;
    for (i = 1; i <= n; i++) 
    {
        cin >> a[i];
        if (rez <= a[i]) rez++;
        else rez--;
    }
    if ((n%2 == 0 && k%2 == 1) || (n%2 == 1 && k%2 == 0))
    {
        cout << "NE" << endl;
        return 0;
    }
    if (rez == k)
    {
        cout << "DA" << endl;
        for (i = 1; i <= n; i++) cout << a[i] << endl;
    }
    else cout << "NE" << endl;
    return 0;
}